<template>
  <q-page>
    <div class="q-pa-sm column">
      <div class="row fullwidth">
        <q-form
          @submit="onSubmit"
          @reset="onReset"
          class="q-gutter-md"
          :class="$q.screen.xs ? 'col-12' : 'col-10 offset-1'"
        >
          <q-input
            filled
            v-model="title"
            label="Event title"
            lazy-rules
            :rules="[val => (val && val.length > 0) || 'Please type something']"
          />

          <q-input
            filled
            type="textarea"
            v-model="description"
            label="Description"
            lazy-rules
            :rules="[val => (val && val.length > 0) || 'Please type something']"
          />

          <q-input
            filled
            v-model="location"
            label="Event location"
            lazy-rules
            :rules="[val => (val && val.length > 0) || 'Please type something']"
          />
          <q-input
            filled
            v-model="startTime"
            label="Start time"
            lazy-rules
            :rules="[val => (val && val.length > 0) || 'Please type something']"
          />
          <q-input
            filled
            v-model="endTime"
            label="End time"
            lazy-rules
            :rules="[val => (val && val.length > 0) || 'Please type something']"
          />
          <q-input
            filled
            v-model="attendeeList"
            label="Attendees"
            hint="Comma-separtated list of attendees"
            lazy-rules
            :rules="[val => (val && val.length > 0) || 'Please type something']"
          />

          <div class="text-right">
            <q-btn
              label="Reset"
              type="reset"
              color="secondary"
              flat
              class="q-ml-sm"
            />
            <q-btn label="Submit" type="submit" color="secondary" />
          </div>
        </q-form>
      </div>
    </div>
  </q-page>
</template>

<script>
import { mapActions } from "vuex";
import HoverEvent from "../models/events";

export default {
  name: "PageAddEvent",
  props: ["day"],
  data() {
    return {
      title: null,
      description: null,
      location: null,
      startTime: null,
      endTime: null,
      attendeeList: null,
      accept: false
    };
  },

  methods: {
    ...mapActions(["addEvent"]),
    async onSubmit() {
      let attendees = this.attendeeList.split(",");
      let ev = new HoverEvent({
        calendarId: 1,
        title: this.title,
        description: this.description,
        location: this.location,
        startTime: this.startTime,
        endTime: this.endTime,
        attendees: attendees
      });

      console.log(ev);
      await this.addEvent({ day: this.day, event: ev });
      this.$router.go(-1);
      this.$q.notify({
        color: "green-4",
        textColor: "white",
        icon: "cloud_done",
        message: "Submitted"
      });
    },

    onReset() {
      this.name = null;
      this.age = null;
      this.accept = false;
    }
  }
};
</script>
